function [list_X,list_T,Data_X,Data_T,dest_fr,inhab,amount_fractions,amount_flows,process_category,bio_tr,rest_index,txt_out,txt_KPI,company_level,km,E_tr,E_pr,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy,txt_em,txt_fractions,txt_type,txt_flows,txt_incinerated,txt_AD] = read_data( filename )
%SUMMARY: this function reads all data from excel and makes it available
%for the other functions used in the generic model.

disp('reading data from excel can take a while');
inhab = xlsread(filename,'Data','D5'); % read inhabitants

%% Read Characters

[~,txt,~] = xlsread(filename,'Flows','H5:I14'); %reads the name of the cells that should be read (dynamic)
[~,txt_fractions,~] = xlsread(filename,'Flows','C11:C25'); % reads the names of the fractions
[~,txt_type,~] = xlsread(filename,'Flows','D11:D25'); % reads the names of the ftypes
[~,txt_flows,~] = xlsread(filename,'Energy',char(txt(10,2))); % reads te flows (used in output)

[~,txt_fuels,~] = xlsread(filename,'Energy','C20:C26'); % reads the names of the transport energy carriers
[~,txt_pr_E,~] = xlsread(filename,'Energy','D20:D26');% read the names of the process energy carriers

[~,txt_out,~] = xlsread(filename,'Output','B4:G370'); % reads the position for the struct "output" in the output tab in the result file
[~,txt_KPI,~] = xlsread(filename,'Output','N4:Q8'); % reads the position for the indciators in the result tab in the result file
[~,txt_em,~] = xlsread(filename,'Output','AL4:BA11');% Reads the position where to write the energy consumption from each specific energy carrier in the emissions tab in the result file
[~,txt_incinerated,~] = xlsread(filename,'Output','BF4:BJ8');% Reads the position where to write the detailed information about the generated amount of energy from incineration in the enenrgy tab
[~,txt_AD,~] = xlsread(filename,'Output','BL4:BP8');% Reads the position where to write the detailed information about the generated amount of energy from AD in the energy tab



%% Read data (double)

% Amount of processes, waste fractions and waste type

amount_fractions = xlsread(filename,'Flows','C9');
amount_flows = xlsread(filename,'Flows','D9');
amount_pr = xlsread(filename,'Flows','B11');

% For material layer
disp('50% of the data is imported');

list_X = xlsread(filename,'Flows',char(txt(1,2))); % list with all X (flows) that where defined, each has a unique number used in the program
list_T = xlsread(filename,'Flows',char(txt(2,2))); % list with all T (transfer coefficients) that were defined, each has a unique number
dest_fr = xlsread(filename,'Flows',char(txt(5,2))); % Matrix with all destination for each fraction, defined in the table in the flows tab

Data_X = xlsread(filename,'Data',char(txt(3,2))); % reads all the flow data you provided from the data tab. 
Data_T = xlsread(filename,'Data',char(txt(4,2))); % reads all the transfer coefficient data you provided from the data tab. 

process_category = xlsread(filename,'Flows','B44:F49'); % which processes belong to which indicator
company_level = xlsread(filename,'Flows','C61:F70'); %Company boudary (transpose?)
company_level = company_level'; %transpose so correct order (types horizantally)
bio_tr = xlsread(filename,'Flows','B76:E79'); %optional dry matter adjustment
rest_index = xlsread(filename,'Flows','I43:I46');% which fraction should not be included in the collection efficinecy? (rest)

% For energy layer
cal_val = xlsread(filename,'Energy','D38:D52');% (Kj/kg = Mj/tonn) so correct unit
incineration = xlsread(filename,'Energy','C57:D61'); % reads data about the incineration process
bio_energy = xlsread(filename,'Energy','F57:G61'); % reads data about the biological treatement process. 
km = xlsread(filename,'Energy',char(txt(7,2)));
E_tr = xlsread(filename,'Energy',char(txt(8,2)));
E_pr = xlsread(filename,'Energy',char(txt(9,2)));


disp('reading from excel is done');
end

