function [] = export_energy(File,export_filename,KPI,txt_KPI,energy,txt_emissions,txt_fractions,txt_type,amount_pr,txt_flows,txt_incinerated,txt_AD )
%SUMMARY The function writes the energy information to the scenario file.

Excel = actxserver ('Excel.Application');
File = [File,'\',export_filename,];

if ~exist(File,'file')
    ExcelWorkbook = Excel.workbooks.Add;
    ExcelWorkbook.SaveAs(File,1);
    ExcelWorkbook.Close(false);
end
invoke(Excel.Workbooks,'Open',File);

disp('writing energy layer started');
process = 1:amount_pr;

%% Output tab

% inflow of each process in output tab
xlswrite1(export_filename,cellstr('Inflow of each process (t/yr)'),'Output','U2');
xlswrite1(export_filename,cellstr('Process'),'Output','U3')
xlswrite1(export_filename,cellstr(txt_type'),'Output','V3');
xlswrite1(export_filename,process','Output','U4');
xlswrite1(export_filename,energy(5).matrix,'Output','V4');

%% Result tab

%determine location of enenrgy overview table
location_names = (5+size(txt_fractions,1)+4):(5+size(txt_fractions,1)+8);
location_data = (5+size(txt_fractions,1)+4):(5+size(txt_fractions,1)+5); 
names =strcat({'M'},num2str(location_names'));
data = strcat({'N'},num2str(location_data'));
%inincerated overview in results tab
xlswrite1(export_filename,cellstr(txt_fractions),'Results',char(txt_KPI(5,2)));
xlswrite1(export_filename,cellstr(KPI(6).name),'Results',char(txt_KPI(5,1)));
xlswrite1(export_filename,KPI(6).fractions,'Results',char(txt_KPI(5,3)));
xlswrite1(export_filename,KPI(6).matrix,'Results',char(txt_KPI(5,4)));
% energy effeciency in results tab
xlswrite1(export_filename,cellstr('Energy efficiency'),'Results',char(names(1,1)));
xlswrite1(export_filename,cellstr('Feedstock E. (kwh)'),'Results',char(names(2,1)));
xlswrite1(export_filename,cellstr('Transport E. (kwh)'),'Results',char(names(3,1)));
xlswrite1(export_filename,cellstr('Process E. (kwh)'),'Results',char(names(4,1)));
xlswrite1(export_filename,cellstr('Generated E. (kwh)'),'Results',char(names(5,1)));
xlswrite1(export_filename,KPI(7).fractions,'Results',char(data(2,1)));%overview
xlswrite1(export_filename,KPI(7).eff_tot,'Results',char(data(1,1)));

%% Energy tab

%transport energy in energy tab
xlswrite1(export_filename,cellstr('Transport Energy (kwh)'),'Energy','C3');
xlswrite1(export_filename,cellstr('Flow'),'Energy','C5')
xlswrite1(export_filename,cellstr(txt_flows),'Energy','C6');
xlswrite1(export_filename,cellstr(txt_type'),'Energy','D5');
xlswrite1(export_filename,energy(2).matrix,'Energy','D6');%transport
%Process energy in energy tab
xlswrite1(export_filename,cellstr('Process Energy (kwh)'),'Energy','L3')
xlswrite1(export_filename,cellstr('Process'),'Energy','L5')
xlswrite1(export_filename,cellstr(txt_type'),'Energy','M5');
xlswrite1(export_filename,process','Energy','L6');
xlswrite1(export_filename,energy(3).matrix,'Energy','M6');%process
%feedstock energy in energy tab
xlswrite1(export_filename,cellstr('Feedstock Energy (kwh)'),'Energy','T3')
xlswrite1(export_filename,cellstr(txt_fractions),'Energy','T6')
xlswrite1(export_filename,cellstr(txt_type'),'Energy','U5');
xlswrite1(export_filename,energy(1).matrix,'Energy','U6');%feedstock
%energy generated in energy tab
xlswrite1(export_filename,cellstr('Overview energy generated'),'Energy','AD3')
xlswrite1(export_filename,cellstr('Energy (kwh)'),'Energy','AE5');
xlswrite1(export_filename,cellstr('Process'),'Energy','AD5');
xlswrite1(export_filename,cellstr('Burning value (MJ/kg)'),'Energy','AF5');
xlswrite1(export_filename,energy(4).matrix,'Energy','AD6');%Out
% Detail of energy generated from incineration in energy tab
xlswrite1(export_filename,cellstr('Energy generated from Incineration (kwh)'),'Energy','AI3')
for i=1:size(energy(4).carriers(1).struct,2)
     xlswrite1(export_filename,cellstr('Process'),'Energy',char(txt_incinerated(i,1)));
     xlswrite1(export_filename,energy(4).carriers(1).struct(i).process,'Energy',char(txt_incinerated(i,2)));
     xlswrite1(export_filename,cellstr(txt_type'),'Energy',char(txt_incinerated(i,3)));
     xlswrite1(export_filename,cellstr(txt_fractions),'Energy',char(txt_incinerated(i,4)));
     xlswrite1(export_filename,energy(4).carriers(1).struct(i).energy_out,'Energy',char(txt_incinerated(i,5)));
end
% Detail of energy generated from AD in energy tab
xlswrite1(export_filename,cellstr('Energy generated from AD (kwh)'),'Energy','AR3')
for i=1:size(energy(4).carriers(2).struct,2)
     xlswrite1(export_filename,cellstr('Process'),'Energy',char(txt_AD(i,1)));
     xlswrite1(export_filename,energy(4).carriers(2).struct(i).process,'Energy',char(txt_AD(i,2)));
     xlswrite1(export_filename,cellstr(txt_type'),'Energy',char(txt_AD(i,3)));
     xlswrite1(export_filename,cellstr(txt_fractions),'Energy',char(txt_AD(i,4)));
     xlswrite1(export_filename,energy(4).carriers(2).struct(i).energy_out,'Energy',char(txt_AD(i,5)));
end

%% Energy Carriers tab

% Detail of transport enegry in energy carriers tab
for i =1:size(energy(2).carriers,2) %transport
    xlswrite1(export_filename,energy(2).carriers(i).type,'Energy_carriers',char(txt_emissions(1,i)));
    xlswrite1(export_filename,cellstr('Flows'),'Energy_carriers',char(txt_emissions(2,i)));
    xlswrite1(export_filename,cellstr(txt_flows),'Energy_carriers',char(txt_emissions(3,i)));
    xlswrite1(export_filename,cellstr('Total'),'Energy_carriers',char(txt_emissions(4,i)));
    xlswrite1(export_filename,energy(2).carriers(i).kwh,'Energy_carriers',char(txt_emissions(5,i)));
    xlswrite1(export_filename,cellstr(txt_type'),'Energy_carriers',char(txt_emissions(6,i)));
    xlswrite1(export_filename,energy(2).carriers(i).energy,'Energy_carriers',char(txt_emissions(7,i)));
    xlswrite1(export_filename,cellstr('Transport energy (kwh) for'),'Energy_carriers',char(txt_emissions(8,i)));
end
% Detail of process enegry in energy carriers tab
for i =1:size(energy(3).carriers,2) %process
    xlswrite1(export_filename,energy(3).carriers(i).type,'Energy_carriers',char(txt_emissions(1,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,cellstr('Process'),'Energy_carriers',char(txt_emissions(2,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,process','Energy_carriers',char(txt_emissions(3,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,cellstr('Total'),'Energy_carriers',char(txt_emissions(4,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,energy(3).carriers(i).kwh,'Energy_carriers',char(txt_emissions(5,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,cellstr(txt_type'),'Energy_carriers',char(txt_emissions(6,i+size(energy(2).carriers,2))));
    xlswrite1(export_filename,energy(3).carriers(i).energy,'Energy_carriers',char(txt_emissions(7,i+size(energy(2).carriers,2)))) 
    xlswrite1(export_filename,cellstr('Process energy (kwh) for'),'Energy_carriers',char(txt_emissions(8,i+size(energy(2).carriers,2))));
end

invoke(Excel.ActiveWorkbook,'Save');
Excel.Quit
Excel.delete
clear Excel
disp('writing energy layer done');

end


