function [KPI] = energy_indicators( KPI, amount_fractions,amount_flows,energy_over)
%SUMMARY This small function adds the energy struct and an overview of all waste being incinerated to the KPI struct

%Incineration matrix
index = 6;
[incineration_matrix] = incinerated(amount_fractions,amount_flows,energy_over);
KPI(index).name = 'Incinerated';
KPI(index).matrix = incineration_matrix;
KPI(index).fractions = sum(incineration_matrix,2);

%Energy eff
index = 7;
[energy_eff, energy_overview] = energy(energy_over);
KPI(index).name = 'Energy struct';
KPI(index).matrix = energy_over; %struct
KPI(index).fractions = energy_overview; % a matrix with the total values of transport, process, feedstock and generated energy
KPI(index).eff_tot = energy_eff;

end


function[incineration_matrix] = incinerated(amount_fractions,amount_flows,energy_over)
incineration_matrix = zeros(amount_fractions,amount_flows);            
for j=1:size(energy_over(4).carriers(1).struct,2)
    incineration_matrix = incineration_matrix + energy_over(4).carriers(1).struct(j).input;
end 
end

function[energy_eff,energy_overview] = energy(energy_over)    
    
    energy_overview(1,1)= energy_over(1).total;%feedstock
    energy_overview(2,1) = energy_over(2).total;%transport
    energy_overview(3,1) = energy_over(3).total;%process
    energy_eff = energy_over(4).total/sum(energy_overview(:,1));
    energy_overview(4,1) = energy_over(4).total;%out
end



